#!/bin/sh

# Wrapper Script to build the NOvA-DDT software.
# This sources the development release of the software
# and updates all of the packages.
# It then calls a perl script to make a clean build 
# in standard and debug modes.
#
# November 20, 2012 - Martin Frank (based on Gavin S. Davies' ART script)
#
#set the HOSTNAME explicitly because it doesn't seem to get picked up otherwise
#it is ok to set it like this because we will always build the FNAL version on novagpvm07.fnal.gov
export HOSTNAME=novagpvm07.fnal.gov

logfile=/grid/fermiapp/nova/novaddt/novaddt_make.log
echo "Output written to" $logfile

echo "Setting up Environment" > $logfile
source /grid/fermiapp/nova/novaddt/srt/srt.sh >> $logfile 2>&1
#export EXTERNALS=/nusoft/app/externals
export EXTERNALS=/grid/fermiapp/products/nova/externals
source $SRT_DIST/setup/setup_novaddt.sh "$@" >> $logfile 2>&1

echo "Updating $SRT_DIST/setup first:" >> $logfile
cd $SRT_DIST/setup
svn update >> $logfile 2>&1

cd $SRT_PUBLIC_CONTEXT

echo "Starting FNAL NOvA-DDT Update at " >> $logfile
date >> $logfile
update-release >> $logfile 2>&1
echo `date`  Update Release Finished

novaddt_build -rel development >> $logfile 2>&1
echo `date`  Build Release Finished

$SRT_PUBLIC_CONTEXT/SRT_NOVADDT/scripts/update_novaddt_doxygen >> $logfile 2>&1
echo `date`  Update Doxygen Finished


$SRT_PUBLIC_CONTEXT/SRT_NOVADDT/scripts/make_nova_build_log $logfile
echo `date`  All Finished
echo
echo "http://nusoft.fnal.gov/nova/novaddt/logs/latest_build.html"

